////////////////////////////////////////////////////////////////////////////////
// SUNSHINE'S RVA CALCULATOR
// Version 1.0
// coded with Delphi 15.2.2002

// Well, bad source without comments. IF you wanna understand this mess, you must
// be quite good. But try it. Have also a look at readme.txt

// www.sunshine.2kx.de
// Questions, ideas, critics? Mail me: Lloret01@gmx.de
// YES I KNOW THERE ARE BUGS BUT I'M TOO LAZY ;-)
////////////////////////////////////////////////////////////////////////////////

program RVACalc;

uses
  Windows, Messages, window, commdlg, classes, sysutils;

const
  WindowWidth = 248;
  WindowHeight = 420;
  ziffern : string = '1234567890';
  zeichen : string = 'abcdefABCDEF0123456789';
  
var
  //OPENFILENAME
  ofn : OPENFILENAME;
  filterstring : LPCTSTR =
                 'Executable Files (*.exe, *.dll)'+#0+'*.exe;*.dll'+#0+
                 'All Files (*.*)'+#0+'*.*'+#0+#0;

  filename : array[0..MAX_PATH] of char;

  hwndbackgr : Integer;
  vir_offs, virsize : array[1..20] of  DWORD;
  raw_offs, rawsize : array[1..20] of DWORD;
  charac :  DWORD;
  which_sec : Integer;
  elfanew : DWORD = $00;
  peheader : DWORD = $00;
  Imagebase : DWORD = $00;
  number_sec : byte;

  focus : Integer;
{$R Dlg.RES}

// help function for my hextoint function
Function hoch(a,b : Integer) : Integer;
var
  i : integer;
begin
  result := 1;
  for i := 1 to b do
    result := result * a;
end;

// also a help function for hextoint
function converthexziffer(ziffer : string) : Integer;
var
  t : Integer;
begin
   t := 0;
   case ziffer[1] of
       'a' : t := 10;  '0' : t := 0;
       'A' : t := 10;  '1' : t := 1;
       'b' : t := 11;  '2' : t := 2;
       'B' : t := 11;  '3' : t := 3;
       'c' : t := 12;  '4' : t := 4;
       'C' : t := 12;  '5' : t := 5;
       'd' : t := 13;  '6' : t := 6;
       'D' : t := 13;  '7' : t := 7;
       'e' : t := 14;  '8' : t := 8;
       'E' : t := 14;  '9' : t := 9;
       'f' : t := 15;
       'F' : t := 15;
       end;
       result := t;
end;

// converts a hexadecimal number into decimal
function hextoint(hex : string) : Integer;
var
  i,temp : Integer;
begin
  result := 0;
  for i := length(hex) - 1 downto 0 do
  begin
    temp := converthexziffer(copy(hex,length(hex)-i,1)) * hoch(16,i);
    result := result + temp;
  end;
end;

// it's self explaining, isn't it?
procedure ClearAllEdits(dialog : HWND);
begin
  SetDlgItemText(dialog,1001,pchar(' '));
  SetDlgItemText(dialog,1002,pchar(' '));
  SetDlgItemText(dialog,1003,pchar(' '));
  SetDlgItemText(dialog,1004,pchar(' '));
  SetDlgItemText(dialog,1005,pchar(' '));
end;

// converts an RVA to a file-based offset. It loops through each section to find out
// in which section inserted RVA is.
procedure RVA2Offset(va : DWORD; filename : string; dialog : HWND);
var
  i: Integer;
begin
  which_sec := 0;
  for i := 1 to number_Sec  do
  begin
    if (VA >= vir_offs[i]) and (va < vir_offs[i+1]) then
    begin
      which_sec := i;
      break;
    end;
    if i = number_Sec then
      if (VA <= vir_offs[i] + virsize[i]) and (VA >= vir_offs[1])
      then
        which_sec := i
      else
      begin
        MessageBox(0,pchar('Not in file!'),pchar('Error'),mb_ok);
        ClearAllEdits(dialog);
        exit;
      end;
    end;

    SetDlgItemText(dialog,1003,pchar(inttohex(VA - vir_offs[which_Sec] + raw_offs[which_Sec],8)));
end;

// get needed info about the sections for RVA Calculating
procedure GetFileInfo(filename : string; dialog : HWND);
var
  f : TFilestream;
  i : Integer;
begin
  f := TFileStream.Create(filename,fmopenreadwrite);
  // File address of new Exe header
  f.Seek($3C,sofrombeginning);
  f.Read(elfanew,4);
  // PE Header
  f.Seek(elfanew,sofrombeginning);
  f.Read(peheader,2);
  if  not (peheader = $4550) then
  begin
     MessageBox(0,pchar('Not a valid PE File'),pchar('Error'),
                mb_iconinformation);
     f.Free;
     exit;
  end;
  // Number of Sections
  f.seek(4,sofromcurrent);
  f.Read(number_sec,2);
  // Imagebase
  f.seek($2c,sofromcurrent);
  f.Read(Imagebase,4);
  // Section Info
  f.Seek(elfanew + $f8,sofrombeginning);
    for i := 1 to number_sec do
    begin
      f.seek(8, sofromcurrent);
      //Vir_size
      f.Read(virsize[i],4);
      // Virtual Adress
      f.Read(vir_offs[i],4);
      // Raw size
      f.Read(rawsize[i],4);
      // Raw Offset
      f.Read(raw_offs[i],4);
      // Characteristics
      f.seek(12,sofromcurrent);
      f.Read(charac,4);
    end;
  EnableWindow(Getdlgitem(dialog,1001),true);
  EnableWindow(Getdlgitem(dialog,1002),true);
  EnableWindow(Getdlgitem(dialog,1003),true);
  EnableWindow(Getdlgitem(dialog,1004),true);
  EnableWindow(Getdlgitem(dialog,1005),true);
  f.free;
end;

procedure Offset2RVA(offset : DWORD; filename : string; dialog : HWND);
var
  i: Integer;
begin
  for i := 1 to number_Sec  do
  begin
    if i = number_sec then which_sec := i;
    if (offset >= raw_offs[i]) and (offset < raw_offs[i+1]) then
    begin
      which_sec := i;
      break;
    end;
    if i = number_sec then
    begin
      if offset < raw_offs[1] then
      begin
        SetDlgItemtext(dialog,1002,pchar(inttohex(offset,8)));
        exit;
      end;
      if offset > raw_offs[i] + rawsize[i] then
      begin
        MessageBox(0,pchar('Too big'),pchar('Error'),mb_ok);
        ClearAllEdits(dialog);
        exit;
      end;
    end;
  end;

  SetDlgItemText(dialog,1002,pchar(inttohex(offset - raw_offs[which_Sec] + vir_offs[which_Sec],8)));
end;

procedure ReadBytes(filename : string; dialog : HWND);
var
  f : TFileStream;
  b : byte;
  i : Integer;
  s : array[0..MAX_PATH] of char;
begin
  GetDlgItemtext(dialog,1004,s,sizeof(s));
  if strlen(s) = 0 then exit;
  f := TFileStream.Create(filename,fmopenreadwrite);
  f.seek(strtoint(s),sofrombeginning);
  ZeroMemory(@s,sizeof(s));
  for i := 1 to 6 do
  begin
    f.Read(b,1);
    lstrcat(s,pchar(inttohex(b,2)));
    lstrcat(s,pchar('  '));
  end;
  SetDlgItemtext(dialog,1005,s);
  f.free;
end;


function DlgProc(Dialog: HWnd; Msg, WParam: Word; LParam: Longint): BOOL; stdcall;
var
  x,y : Integer;
  dc: HDC;
  ps: TPaintStruct;
  hMemDC: HDC;
  rect  : TRect;
  tstr : array[0..MAX_PATH] of char;
  t : Integer;
  temp : DWORD;
begin
  case Msg of
    WM_INITDIALOG :
    begin
      CreateOddWindow(dialog, false);
      x := GetSystemMetrics(SM_CXSCREEN);   //Screenhhe & -breite
      y := GetSystemMetrics(SM_CYSCREEN);
      MoveWindow(Dialog, (x div 2) - (WindowWidth div 2),
                (y div 2) - (WindowHeight div 2),
                 WindowWidth, WindowHeight, true);
      hwndbackgr := LoadBitmap(hInstance,MAKEINTRESOURCE(104));
    end;

    WM_CLose:
    begin
      DeleteObject(hwndbackgr);
      PostquitMessage(0);
    end;

    WM_LBUTTONDOWN:
      begin
        ReleaseCapture;
        SendMessage(dialog,WM_SYSCOMMAND,$f012,0);
      end;

    WM_PAINT:
    begin
      dc := BeginPaint(dialog, ps);
      hMemDC := CreateCompatibleDC(dc);
      SelectObject(hMemDC, hwndbackgr);
      GetClientRect(dialog, rect);
      BitBlt(dc, 1, 1, rect.right, rect.bottom, hMemDC, 0, 0, SRCCOPY);
      DeleteDC(hMemDC);
      EndPaint(dialog, ps);
    end;


    WM_COMMAND:
    begin
    if HIWord(wparam) = BN_CLICKED then
    case loword(wParam) of
    1000 : begin
           ofn.lStructSize := sizeof(ofn);
           ofn.hWndOwner := dialog;
           ofn.hInstance   := HInstance;
           ofn.lpstrFilter := filterstring;
           ofn.lpstrFile := filename;
           ofn.nMaxFile :=  512;
           ofn.lpstrTitle := 'Choose file...';
           ofn.Flags := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or
                        OFN_EXPLORER or OFN_HIDEREADONLY;
           if Getopenfilename(ofn) then
           begin
             Getfileinfo(filename, dialog);
           end;

           end;
    1007 : PostQuitMessage(0);
    1006 : begin
             ShowWindow(dialog,SW_MINIMIZE);
           end;
    1008 : begin
             focus := GetFocus;
             ClearAllEdits(dialog);
             if focus = getdlgitem(dialog,1001) then  // VA Edit
             begin
                //RVA
                GetWindowtext(focus,tstr,sizeof(tstr));
                t := hextoint(tstr);
                SetWindowText(getdlgitem(dialog,1002),pchar(inttohex(t-Imagebase,6)));
                //Offset
                GetWindowtext(getdlgitem(dialog,1002),tstr,sizeof(tstr));
                temp := hextoint(tstr);
                RVA2Offset(temp, filename, dialog);
                GetdlgitemText(dialog,1003,tstr,sizeof(tstr));
                if lstrlen(tstr) = 0 then
                begin
                  ClearAllEdits(dialog);
                  DlgProc := false;
                  exit;
                end;
                // decimal
                GetdlgitemText(dialog,1003,tstr,sizeof(tstr));
                temp := hextoint(tstr);
                SetDlgItemtext(dialog,1004,pchar(inttostr(temp)));
                // Read Bytes
                ReadBytes(filename, dialog);
             end;

             if focus = getdlgitem(dialog,1002) then // RVA Edit
             begin
               // VA
               GetWindowtext(focus,tstr,sizeof(tstr));
               t := hextoint(tstr);
               SetDlgItemText(dialog,1001,pchar(inttohex(Imagebase + t,8)));
               // decimal
               temp := hextoint(tstr);
               SetDlgItemtext(dialog,1004,pchar(inttostr(temp)));
               ReadBytes(filename, dialog);
               GetWindowtext(focus,tstr,sizeof(tstr));
               temp := hextoint(tstr);
               RVA2Offset(temp, filename, dialog);
               GetdlgitemText(dialog,1003,tstr,sizeof(tstr));
               if lstrlen(tstr) = 0 then
               begin
                 ClearAllEdits(dialog);
                 DlgProc := false;
                 exit;
               end;

             end;

            if focus = getdlgitem(dialog,1003) then  // HEX Edit
            begin
              //RVA
              GetdlgItemText(dialog,1003,tstr,sizeof(tstr));
              temp := hextoint(tstr);
              Offset2RVA(temp,filename,dialog);
              // calculate VA
              GetDlgItemText(dialog,1002,tstr,sizeof(tstr));
              t := hextoint(tstr);
              SetDlgItemText(dialog,1001,pchar(inttohex(Imagebase + t,8)));
              // decimal
              GetdlgItemText(dialog,1003,tstr,sizeof(tstr));
              temp := hextoint(tstr);
              SetDlgItemtext(dialog,1004,pchar(inttostr(temp)));
              ReadBytes(filename, dialog);
           end;

           if focus = getdlgitem(dialog,1004) then  // Dec Edit
           begin
             //HEX
             GetdlgItemText(dialog,1004,tstr,sizeof(tstr));
             t := strtoint(tstr);
             SetDlgItemtext(dialog,1003,pchar(inttohex(t,8)));
             //RVA
             GetDlgItemText(dialog,1003,tstr,sizeof(tstr));
             temp := hextoint(tstr);
             Offset2RVA(temp,filename,dialog);
             GetdlgitemText(dialog,1002,tstr,sizeof(tstr));
             // calculate VA
             t := hextoint(tstr);
             SetDlgItemtext(dialog,1001,pchar(inttohex(ImageBase + t,8)));
             Readbytes(filename, dialog);
           end;
         end;


  end;

  end;
  end;
  DlgProc := false;
end;

begin
  DialogBoxParam(hInstance, PChar('Dlg'), 0, @DlgProc, 0);
  ExitProcess(hInstance);
end.

